import java.io.*;
import java.net.*;
import yawlservice.*;

/** A client-side class that uses a TCP/IP socket
 */
public class DeclareServiceClient {

  private PrintWriter out = null;

 /** Constructor
   * @param host String address of the host
   *        where the server is located
   * @param port Port number on the host where
   *        the server is listening
   */
  public DeclareServiceClient(String host, int port) throws Exception{
    super();
    Socket socket = new Socket(host, port);
    out = new PrintWriter(socket.getOutputStream(),true);
  }

  public DeclareServiceClient(int port) throws Exception{
    super();
    Socket socket = new Socket(getLocalHost(), port);
    out = new PrintWriter(socket.getOutputStream(),true);
  }

  private String getLocalHost() throws Exception{
    return InetAddress.getLocalHost().getHostAddress();
  }

  /** The method used to start a client object
   */
  public boolean send(YAWLMessage msg) {
    return send(msg.toString());
  }

  /** The method used to start a client object
   */
  public boolean send(String msg) {
       try {
         out.println(msg);
         return true;
       }
       catch (Exception iox) {
         iox.printStackTrace();
         return false;
    }
  }
}
