package yawlservice;

import org.w3c.dom.*;

public class CaseDataElement { // extends Item

  private static final String VALUE = "value";
  private static final String NAME = "name";

  private String _value;
  private String _name;

  //constructors
  public CaseDataElement(String p_name, String p_value) {
    this._name = validate(p_name);
    this.setValue(p_value);
  }

  public CaseDataElement(Element element) {
    _name = validate(XMLParser.getSimpleElementText(element, NAME));
    this.setValue(XMLParser.getSimpleElementText(element, VALUE));
  }

  public String getName() {
    return _name;
  }

  public void setValue(String p_value) {
    if ( p_value == null ) p_value = "NOT_DEFINED";
    _value = p_value;
  }

  public String getValue() {
    return _value;
  }

  private String validate(String attribute){
    if ( attribute == null ) attribute = "";
    return attribute;
  }

  public Element toElement(Document document) {

    Element element = document.createElement(_name);
    element.appendChild(document.createTextNode(validate(_value)));

    return element;
  }

  public void fromElement(Element element) {
    if (element != null) {
      this._name = element.getTagName();
      this._value = XMLParser.getSimpleElementText(element, VALUE);
    }
  }
}
